program test;

{$APPTYPE CONSOLE}

uses
  Windows,
  WinSvc,
  SysUtils;

const
  ServiceName = 'CRC32DRIVER';

function Install: Boolean;
var
  SCManager, Service: SC_HANDLE;
  qwe: pchar;
begin
  SCManager := OpenSCManager(nil, nil, SC_MANAGER_CREATE_SERVICE);
  if SCManager <> 0 then
  try
    Service := CreateService(SCManager, PChar(ServiceName), PChar(ServiceName),
      SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER,
      SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL,
      PChar(ExtractFilePath(ParamStr(0)) + 'crc.sys'),
      nil, nil, nil, nil, nil);
    if Service <> 0 then
    try
      Result := ChangeServiceConfig(Service, SERVICE_NO_CHANGE,
        SERVICE_NO_CHANGE, SERVICE_NO_CHANGE, nil, nil,
        nil, nil, nil, nil, nil);
      qwe := nil;
      if Result then
        Result := StartService(Service, 0, qwe);
    finally
      CloseServiceHandle(Service);
    end
    else
      Result := GetLastError = ERROR_SERVICE_EXISTS;
  finally
    CloseServiceHandle(SCManager);
  end
  else
    Result := False
end;

function TestDriver: Boolean;
const
  IOCTL_CALC_CRC = $22E000;
var
  hDriver: THandle;
  Path: String;
  CRC, dwBytesReturned: DWORD;
begin
  Result := False;
  hDriver := CreateFile('\\.\CRCChecker', GENERIC_READ or GENERIC_WRITE,
    0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if hDriver <> INVALID_HANDLE_VALUE then
  try
    Path := '\??\' + ParamStr(0);
    Result := DeviceIoControl(hDriver,
      IOCTL_CALC_CRC,
      @Path[1], Length(Path),
      @CRC, 4,
      dwBytesReturned, nil);
    if not Result then
      Writeln(SysErrorMessage(GetLastError))
    else
      Writeln('CRC size = ', dwBytesReturned, ' and CRC = ', IntToHex(CRC, 8));

  finally
    CloseHandle(hDriver);
  end;
end;

function UnInstall: Boolean;
var
  SCManager, Service: SC_HANDLE;
  ss: TServiceStatus;
begin
  SCManager := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
  if SCManager <> 0 then
  try
    Service := OpenService(SCManager, ServiceName, SERVICE_ALL_ACCESS);
    if Service <> 0 then
    try
      Result := ControlService(Service, SERVICE_CONTROL_STOP, ss);
      if not Result then
        Result := GetLastError = ERROR_SERVICE_NOT_ACTIVE;
      if Result then
        Result := DeleteService(Service);
    finally
      CloseServiceHandle(Service);
    end
    else
      Result := GetLastError = ERROR_SERVICE_DOES_NOT_EXIST;
  finally
    CloseServiceHandle(SCManager);
  end
  else
    Result := False;
end;

var
  q: Boolean;
begin
  try
    q := Install;
    writeln('Install: ', q);
    if not q then
      Writeln(SysErrorMessage(GetLastError));
    readln;
    writeln('TestDriver: ', TestDriver);
    readln;
    writeln('Uninstall: ', uninstall);
    readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
