; Simple test driver
; Created by Ct757

format PE native 4.0 at 10000h
entry DriverEntry

  include 'win32a.inc'
  include 'myincs.inc'
  include 'DDK\ntstatus.inc'
  include 'DDK\ntddk.inc'
  include 'DDK\stuff.inc'

section '.main' code readable writeable executable notpageable

       u_str	  usSymLink,'\??\szrDriver'
       u_str	  usDevName,'\Device\szrDevice'

       u_str	  usHelloWorld,'HELLO, WORLD!'

  proc DispatchControl pDeviceObject, pIrp
    locals
      status	dd ?
      hKernel	dd ?
    endl
	push	  esi edi

	mov	  edi,[pIrp]
	assume	  edi,IRP

	mov	  eax,[.edi.CurrentStackLocation]
	assume	  eax,IO_STACK_LOCATION

    .error:
	mov	  [.edi.IoStatus.Status],STATUS_INVALID_DEVICE_REQUEST
	mov	  [.edi.IoStatus.Information],0

    .exit:
	fastcall  IofCompleteRequest,[pIrp],IO_NO_INCREMENT

	pop	  edi esi
	mov	  eax,[status]
	ret
  endp

  proc DispatchCreateClose pDeviceObject, pIrp
	mov	  eax, [pIrp]
	mov	  [eax+IRP.IoStatus.Status],STATUS_SUCCESS
	and	  [eax+IRP.IoStatus.Information],0
	fastcall  IofCompleteRequest,[pIrp],IO_NO_INCREMENT

	mov	  eax,STATUS_SUCCESS
	ret
  endp

  proc DriverUnload pDriverObject
	invoke	  IoDeleteSymbolicLink,usSymLink

	mov	  eax,[pDriverObject]
	invoke	  IoDeleteDevice,[eax+DRIVER_OBJECT.DeviceObject]

	ret
  endp

  proc DriverEntry pDriverObject, usRegistryPath
    locals
      status	    dd ?
      pDeviceObject dd ?
    endl

	lea	  eax,[pDeviceObject]
	invoke	  IoCreateDevice,[pDriverObject],0,usDevName,FILE_DEVICE_UNKNOWN,0,0,eax
	test	  eax,eax
	jne	  .exit

	invoke	  IoCreateSymbolicLink,usSymLink,usDevName
	test	  eax,eax
	jne	  .del_dev

	mov	  eax,[pDriverObject]
	mov	  [eax+DRIVER_OBJECT.DriverUnload],DriverUnload
	mov	  [eax+DRIVER_OBJECT.MajorFunction+IRP_MJ_CREATE*4],DispatchCreateClose
	mov	  [eax+DRIVER_OBJECT.MajorFunction+IRP_MJ_CLOSE*4],DispatchCreateClose
	mov	  [eax+DRIVER_OBJECT.MajorFunction+IRP_MJ_DEVICE_CONTROL*4],DispatchControl

	mov	  [status],STATUS_SUCCESS
	jmp	  .exit

    .del_dev:
	invoke	  IoDeleteDevice,[pDeviceObject]

    .exit:
	mov	  eax,[status]
	ret
  endp

data import

    syslibrary ntoskrnl,'ntoskrnl.exe',\
	       hal,'hal.dll'

    include '\DDK\ntoskrnl.inc'
    include '\DDK\hal.inc'

end data

section '.reloc' data fixups readable discardable

